# Alters aoi schema, adding indexes and foreign key constraints.

# Indexes 

alter table aoi_machine add index idx_machine_aoi_id (aoi_id);

alter table aoi_document add index idx_doc_aoi_id (aoi_id);

alter table aoi_techsys add index idx_techsystem_aoi_id (aoi_id);

alter table aoi_ioc add index idx_ioc_aoi_id (aoi_id);

alter table aoi_topdisplay add index idx_topdisplay_aoi_id (aoi_id);

alter table aoi_note add index idx_note_aoi_id (aoi_id);

alter table aoi_revhistory add index idx_revhistory_aoi_id (aoi_id);

alter table aoi_criticality add index idx_criticality_aoi_id (aoi_id);

alter table aoi_dbload add index idx_dbload_aoi_id (aoi_id);

alter table aoi_plc add index idx_plc_aoi_id (aoi_id);

alter table aoi_rec add index idx_rec_aoi_id (aoi_id);


# Foreign key constraints

alter table aoi add foreign key fk_aoi_cognizant1_id (aoi_cognizant1_id) references person (person_id) on delete restrict;
alter table aoi add foreign key fk_aoi_cognizant2_id (aoi_cognizant2_id) references person (person_id) on delete restrict;
alter table aoi add foreign key fk_aoi_customer_contact_id (aoi_customer_contact_id) references person (person_id) on delete restrict;
alter table aoi add foreign key fk_aoi_status_id (aoi_status_id) references aoi_status (aoi_status_id) on delete restrict;

alter table aoi_machine add foreign key fk_aoi_id (aoi_id) references aoi (aoi_id) on delete restrict;
alter table aoi_machine add foreign key fk_machine_id (machine_id) references machine (machine_id) on delete restrict;

alter table aoi_document add foreign key fk_aoi_id (aoi_id) references aoi (aoi_id) on delete restrict;
alter table aoi_document add foreign key fk_uri_id (uri_id) references uri (uri_id) on delete restrict;
alter table aoi_document add foreign key fk_doc_type_id (doc_type_id) references doc_type (doc_type_id) on delete restrict;

alter table aoi_topdisplay add foreign key fk_aoi_id (aoi_id) references aoi (aoi_id) on delete restrict;
alter table aoi_topdisplay add foreign key fk_uri_id (uri_id) references uri (uri_id) on delete restrict;

alter table aoi_note add foreign key fk_aoi_id (aoi_id) references aoi (aoi_id) on delete restrict;

alter table aoi_revhistory add foreign key fk_aoi_id (aoi_id) references aoi (aoi_id) on delete restrict;

alter table aoi_techsys add foreign key fk_aoi_id (aoi_id) references aoi (aoi_id) on delete restrict;
alter table aoi_techsys add foreign key fk_technical_system_id (technical_system_id) references technical_system (technical_system_id) on delete restrict;

alter table aoi_ioc add foreign key fk_aoi_id (aoi_id) references aoi (aoi_id) on delete restrict;
alter table aoi_ioc add foreign key fk_ioc_id (ioc_id) references ioc (ioc_id) on delete restrict;

alter table aoi_plc add foreign key fk_aoi_id (aoi_id) references aoi (aoi_id) on delete restrict;
alter table aoi_plc add foreign key fk_plc_id (plc_id) references plc (plc_id) on delete restrict;

alter table aoi_criticality add foreign key fk_aoi_id (aoi_id) references aoi (aoi_id) on delete restrict;
alter table aoi_criticality add foreign key fk_criticality_id (criticality_id) references criticality_type (criticality_id) on delete restrict;

alter table aoi_dbload add foreign key fk_aoi_id (aoi_id) references aoi (aoi_id) on delete restrict;
alter table aoi_dbload add foreign key fk_uri_static_id (uri_static_id) references uri_static (uri_static_id) on delete restrict;

alter table aoi_relation add foreign key fk_aoi1_id (aoi1_id) references aoi (aoi_id) on delete restrict;
alter table aoi_relation add foreign key fk_aoi2_id (aoi2_id) references aoi (aoi_id) on delete restrict;

alter table aoi_parent_child add foreign key fk_aoi_parent_id (aoi_parent_id) references aoi (aoi_id) on delete restrict;
alter table aoi_parent_child add foreign key fk_aoi_child_id (aoi_child_id) references aoi (aoi_id) on delete restrict;

alter table plc add foreign key fk_machine_id (machine_id) references machine (machine_id) on delete restrict;
alter table plc add foreign key fk_technical_system_id (technical_system_id) references technical_system (technical_system_id) on delete restrict;
alter table plc add foreign key fk_plc_cognizant1_id (plc_cognizant1_id) references person (person_id) on delete restrict;
alter table plc add foreign key fk_plc_cognizant2_id (plc_cognizant2_id) references person (person_id) on delete restrict;

alter table aoi_rec add foreign key fk_aoi_id (aoi_id) references aoi (aoi_id) on delete restrict;
alter table aoi_rec add foreign key fk_rec_static_id (rec_static_id) references rec_static (rec_static_id) on delete restrict;






